summaryrefslogtreecommitdiffstats
path: root/target/linux/ar71xx/base-files/etc/hotplug.d/firmware/10-ath9k-eeprom
diff options
context:
space:
mode:
authorGabor Juhos <juhosg@openwrt.org>2012-12-12 16:49:51 +0000
committerGabor Juhos <juhosg@openwrt.org>2012-12-12 16:49:51 +0000
commitdcdfcb75f0271fd68613965f8e34a6bc16d717ab (patch)
treef89b85f1ed7120e7eac401a85df28fce07aeadd0 /target/linux/ar71xx/base-files/etc/hotplug.d/firmware/10-ath9k-eeprom
parent1552af3131cefa5d87ff5d2400df1939c502bb29 (diff)
downloadmaster-31e0f0ae-dcdfcb75f0271fd68613965f8e34a6bc16d717ab.tar.gz
master-31e0f0ae-dcdfcb75f0271fd68613965f8e34a6bc16d717ab.tar.bz2
master-31e0f0ae-dcdfcb75f0271fd68613965f8e34a6bc16d717ab.zip
ar71xx: add user-space support for the NETGEAR WNDR4300
Signed-off-by: Gabor Juhos <juhosg@openwrt.org> SVN-Revision: 34649
Diffstat (limited to 'target/linux/ar71xx/base-files/etc/hotplug.d/firmware/10-ath9k-eeprom')
-rw-r--r--target/linux/ar71xx/base-files/etc/hotplug.d/firmware/10-ath9k-eeprom52
1 files changed, 52 insertions, 0 deletions
diff --git a/target/linux/ar71xx/base-files/etc/hotplug.d/firmware/10-ath9k-eeprom b/target/linux/ar71xx/base-files/etc/hotplug.d/firmware/10-ath9k-eeprom
new file mode 100644
index 0000000000..c46d0931a9
--- /dev/null
+++ b/target/linux/ar71xx/base-files/etc/hotplug.d/firmware/10-ath9k-eeprom
@@ -0,0 +1,52 @@
+#!/bin/sh
+
+ath9k_eeprom_die() {
+ echo "ath9k eeprom: " "$*"
+ exit 1
+}
+
+ath9k_eeprom_extract() {
+ local part=$1
+ local offset=$2
+ local count=$3
+ local mtd
+
+ . /etc/functions.sh
+
+ mtd=$(find_mtd_chardev $part)
+ [ -n "$mtd" ] || \
+ ath9k_eeprom_die "no mtd device found for partition $part"
+
+ dd if=$mtd of=/lib/firmware/$FIRMWARE bs=1 skip=$offset count=$count 2>/dev/null || \
+ ath9k_eeprom_die "failed to extract from $mtd"
+}
+
+[ -e /lib/firmware/$FIRMWARE ] && exit 0
+
+. /lib/ar71xx.sh
+
+board=$(ar71xx_board_name)
+
+case "$FIRMWARE" in
+"soc_wmac.eeprom")
+ case $board in
+ wndr4300)
+ ath9k_eeprom_extract "caldata" 4096 2048
+ ;;
+ *)
+ ath9k_eeprom_die "board $board is not supported yet"
+ ;;
+ esac
+ ;;
+
+"pci_wmac0.eeprom")
+ case $board in
+ wndr4300)
+ ath9k_eeprom_extract "caldata" 20480 2048
+ ;;
+ *)
+ ath9k_eeprom_die "board $board is not supported yet"
+ ;;
+ esac
+ ;;
+esac